<?
// $Id: gendoc.php,v 1.12 2010/07/09 12:34:06 riccardo Exp $

require "../adm/lib/setup.php";
require PRISCILLA_LOCAL_PATH."adm/lib/test_auth.php";

$usertable = $PRISCILLA_SESSION->getvalue('usertable');
$skin = $PRISCILLA_SESSION->getvalue('sk');
$lang = $PRISCILLA_SESSION->getvalue('lingua');

require PRISCILLA_LOCAL_PATH."tools/lang/".$lang."/adm_dialog.diz";

    print"<html><head>";
    include("../adm/include/title.txt");
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"../adm/skin/$skin/default.css\">";
    print "<!--[if lte IE 7]>
			<link rel=\"stylesheet\" type=\"text/css\" href=\"../adm/skin/ie6.css\" />
		<![endif]-->";
    print "<link type=\"text/css\" rel=\"stylesheet\" href=\"../packages/dpSyntaxHighlighter/Styles/SyntaxHighlighter.css\"></link>
           <script src=\"../packages/dpSyntaxHighlighter/Scripts/shCore.js\"></script>
            <script src=\"../packages/dpSyntaxHighlighter/Scripts/shBrushXml.js\"></script>
            <script>
                window.onload = function () {
                    dp.SyntaxHighlighter.ClipboardSwf = '../packages/dpSyntaxHighlighter/Scripts/clipboard.swf';
                    dp.SyntaxHighlighter.HighlightAll('code');
                }
            </script>";
?>


<script type="text/javascript">

function expand(module)
{
    if (!module)
        return;

/*
    var mod = document.getElementById('tags-' + module);
    if (mod.style.display == 'none')
        mod.style.display = '';
    else
        mod.style.display = 'none';
*/

    location.replace('#module_' + module);
}

function expand_tag(tagname)
{
    if (!tagname)
        return;
/*
    var mod = document.getElementById('tag-' + tagname).parentNode.parentNode;
    mod.style.display = 'none';
*/

    location.replace('#tag_' + tagname);
}

</script>
</head>

<?

include("../adm/skin/$skin/body.inc");
include("../adm/include/head_adm.inc.php");


//$indextag = file("indextag.all");
//$indexmodules = file("modules.all");

$tag_data = file_get_contents("listag.all");
$ta_tag_loop = file("indextag.loop");
$a_tag_loop = array();
foreach ($ta_tag_loop as $v)
    $a_tag_loop[] = trim($v);

$module_select = "\n<option value=\"\" selected=\"selected\"></option>";
$tag_linear_select = "\n<option value=\"\" selected=\"selected\"></option>";
$tag_loop_select = "\n<option value=\"\" selected=\"selected\"></option>";

// questa classificazione strutturale è possibile farla solo se si presuppone che il
// formato di estrazione sia sempre lo stesso. cioè: prima nome modulo, poi lista tag con
// nome del tag al primo posto
$struct = array();
preg_match_all("/\s*\\*\\*\s*(module|tag|desc|opt|eg)?:\s*(.*)$/mi", $tag_data, $matches);

$c = -1;
foreach ($matches[1] as $i => $tag) {

    switch ($tag) {
        case 'module':

            if (!count($struct[$current_module])) {
                unset($struct[$current_module]);
            }

            $c = -1;
            $current_module = trim($matches[2][$i]);
            $struct[$current_module] = array();

            $module_select .= "\n<option value=\"".$current_module."\">".$current_module."</option>";
            //echo "<hr /><a name=\"" . "module_" . $matches[2][$i] . "\"><div style=\"background-color:orange\">module <strong>".$matches[2][$i]."</strong></div>\n";
        break;
        case 'tag':
            $c++;
            if (in_array($matches[2][$i], $a_tag_loop)) {
                $tagtype = "loop";
                $tag_loop_select .= "\n<option value=\"".$matches[2][$i]."\">".$matches[2][$i]."</option>";
            }
            else {
                $tagtype = "linear";
                $tag_linear_select .= "\n<option value=\"".$matches[2][$i]."\">".$matches[2][$i]."</option>";
            }

            $struct[$current_module][$c]['tagtype'] = $tagtype;
            $struct[$current_module][$c]['tagname'] = $matches[2][$i];
            //echo "<hr /><a name=\"".$matches[2][$i]."\"><a title=\"torna alla lista tag\" href=\"#tagindex\">^</a><br />type: <em>$tagtype</em><h2>".$matches[2][$i]."</h2></a>\n";
        break;
        case 'desc':
            $struct[$current_module][$c]['desc'] .= "\n<br />" . htmlentities($matches[2][$i], ENT_COMPAT, "UTF-8");
            // echo $current_module . "<h3>".$matches[2][$i]."</h3>";
        break;
        case 'opt':
            $e = explode(" ", $matches[2][$i]);
            $struct[$current_module][$c]['opts'][$e[0]] = substr($matches[2][$i], strlen($e[0]));
            //echo "<div style=\"background-color:#e9e9e9\"><strong>".$e[0]."</strong>: ".substr($matches[2][$i], strlen($e[0]))."</div>\n";
        break;
        case 'eg':
            $struct[$current_module][$c]['eg'] .= "\n<br />".htmlentities($matches[2][$i], ENT_COMPAT, "UTF-8");
            //echo "<div style=\"background-color:#66aaff\">".htmlentities($matches[2][$i], ENT_COMPAT, "UTF-8")."</div>\n";
        break;
    }
}
echo "<h2 class=\"docgentit\">Documentazione Tecnica</h2>";
//echo "<strong class=\"strongdocs\">Select by module</strong> <select name=\"select-module\" id=\"select-module\" onchange=\"expand(this.options[this.selectedIndex].value)\">".$module_select."\n</select>";

echo "<p class=\"selectsdocs\"><strong class=\"strongdocs\">Select by tag linear</strong> <select name=\"select-tag-linear\" id=\"select-tag-linear\" onchange=\"expand_tag(this.options[this.selectedIndex].value)\">".$tag_linear_select."\n</select>";
echo " | <strong class=\"strongdocs\">Select by tag loop</strong> <select name=\"select-tag-loop\" id=\"select-tag-loop\" onchange=\"expand_tag(this.options[this.selectedIndex].value)\">".$tag_loop_select."\n</select></p>";

// stampa indice
echo "<div id=\"docmodules-indice\">\n".
     "<ul class=\"indicemodules-list\">\n";
foreach ($struct as $module => $tags) {

    echo "\t<li><a href=\"#"."module_".$module."\">".$module."</a></li>\n";
}
echo "</ul></div>\n";


// stampa della documentazione raccolta
echo "<div id=\"docmodules-container\"><h3><a name=\"tagmodulesindex\">\n".
     "<ul class=\"modules-list\">\n";
foreach ($struct as $module => $tags) {

    echo "\t<li><h2><a name=\"module_".$module."\" id=\"module_".$module."\" href=\"#"."module_".$module."\">".$module."</a></h2>\n".
         "\t<div id=\"tags-".$module."\">";
    foreach ($tags as $i => $tag) {
        echo "\t<ul class=\"tags-list\">\n";
        echo "\t\t<li id=\"tag-".$tag['tagname']."\">".
             "\n\t\t<a name=\"tag_".$tag['tagname']."\" onclick=\"expand_tag('".$tag['tagname']."')\"></a>".
             "\n\t\t<p style=\"color:#333\"><strong>type</strong> <em>".$tag['tagtype']."</em></p>".
             "\t\t<h2>".$tag['tagname']."</h2>\n".
             "\t\t<p>".$tag['desc']."</p>\n";
        if (is_array($tag['opts']) && count($tag['opts'])) {
            echo "\t\t<p><strong>Options</strong></p><ul class=\"opts-list\">\n";
            foreach ($tag['opts'] as $optname => $optdesc)
                echo "\t\t\t<li><p><strong>".$optname."</strong> ".$optdesc."</p></li>\n";
            echo "\t\t</ul>\n\n";
        }
        echo "\t\t<pre name=\"code\" class=\"html\"><strong>Example:</strong><br />".$tag['eg']."</pre>\n".
             "\t\t<p><a href=\"#module_".$module."\">Back to top module</a> <a href=\"#docmodules-indice\">Back to Top</a></p></li>\n";
        echo "\t</ul>\n";
    }
    echo "\t</div>\n\t</li>\n";
}
echo "</ul></div>\n";

?>

<a name="bottom"></a><br /><div class="credits_full" align="center"><? print adm_about_pj; ?>
   <br /><? print adm_about_online; ?></div>
<!-- questa tabella qui sotto chiude la centratura che si apre nelle testate -->
</td></tr></table>

</body>
</html>
