<?
//
// $Id: util.inc.php,v 1.10 2010-07-06 09:41:05 calicant Exp $
// miscellanena: funzioni di supporto (2003.06.09)

// se la versione del php < 4.3 riscrivo questa func xche' nn esiste
if (!function_exists('file_get_contents'))
{
    function file_get_contents($file)
	{
        $handle = fopen ($file,"r");
		$contents = "";
		do
		{
			$data = fread($handle, 8192);
			if (strlen($data) == 0) break;
		    $contents .= $data;
		} while(true);
		fclose ($handle);
		return $contents;
	}
}
// questa funzione determina se un campo utuilizzato nel tpl
// deve essere interpretato come campo html o come testo piano
// (utilizzato per passare parametro is_html all'editor flash)
function is_plain ($field, $tpl)
{
    $plain_tag = array("title", "head");
	$file = file_get_contents("templates/".$tpl);
	// controllo se e' tra due tag html che richiedono del testo plain
	foreach ($plain_tag as $key=>$val)
		if (preg_match_all("/(<($val)[^>]*>)\{($field)\}(<\/\\2>)/", $file, $regs)) return true;
    // controllo se' valore di un attributo di un tag html
    if (preg_match_all("/(<[\w]+.+<[\w]+=\{($field)\}[\s]*[\w]*[^>]*>)/", $file, $regs)) return true;
    // nn e' ancora ritornato => ritorna false
	return false;
}

function get_setup_vars ($filename) {

    if (!file_exists($filename))
        die("Fatal Error: setup file not found: '$filename'");

    $setupdata = file($filename);

    for ($i = 0; $i < count($setupdata); $i++) {

        $currline = trim($setupdata[$i]);
        
        if ($currline{0} == '$' && strstr($currline, "=") && $currline{strlen($currline) - 1} == ';') {
        
            // explode solo del primo =, gli altri li rimetto
            $linepart = explode('=', $currline);
            if (count($linepart) > 2)
                for ($x = 2; $x <= count($linepart); $x++) $linepart[1] .= '='.$linepart[$x];
            $varname = trim($linepart[0]);
            $varval = trim($linepart[1]);
            
            $varname = substr($varname, 1);
            $varval = substr($varval, 1);
            $varval = substr($varval, 0, -2);

            $setupres[$varname] = $varval;
        }
    } // for
    
return $setupres;    
}

// si aggiunge una pezza per tener conto
// della variabile priscilla_backup_dir aggiunta a posteriori. idem per TESTING

function save_setup_vars ($filename, $setupres) {

$FIRMA = "*** Setup file automatically generated on";
$outfirma = 0;
$outbackupdir = 0;
$outtesting = 0;
$outdbpasswcrpt = 0;
$outserverpath = 0;

    if (!file_exists($filename))
        die("Fatal Error: setup file not found: '$filename'");

    $setupdata = file($filename);
    $outdata = array();

    $currfirma = '<?php //' . $FIRMA . " " . date ('Y-m-d H:i:s') . " *** ?>\n";

    for ($i = 0; $i < count($setupdata); $i++) {
    
        $currline = trim($setupdata[$i]);
        
        if ($currline{0} == '$' && strstr($currline, "=") && $currline{strlen($currline) - 1} == ';') {
        
            $linepart = explode('=', $currline);
            $varname = trim($linepart[0]);
            $varval = trim($linepart[1]);
            
            $varname = substr($varname, 1);
            $varval = substr($varval, 1);
            $varval = substr($varval, 0, -2);

            if (isset($setupres[$varname])) {
                $outline = '$' . sprintf("%-30s = '%s';\n", $varname, $setupres[$varname]);
                $outdata[] = $outline;
		        if ($varname == "priscilla_backup_maxmem")
		            $outbackupmem = 1;
		        if ($varname == "TESTING")
		            $outtesting = 1;
                if ($varname == "dbpasswcrpt")
                    $outdbpasswcrpt = 1;
            }
            else $outdata[] = $setupdata[$i];
          
        } else {
            if (!$outfirma && strstr($currline, $FIRMA)) {
                $outfirma = 1;
                $outdata[] = $currfirma;
            }
            else {
		        if ((!$outbackupmem || !$outtesting || !$outdbpasswcrpt) && substr($currline, 0, 2) == '?>') {
		            if (!$outbackupmem) {
			            $outdata[] = '$' . sprintf("%-30s = '%s';\n", "priscilla_backup_maxmem", $setupres['priscilla_backup_maxmem']);
			            $outbackupmem = 1;
		            }
		            if (!$outtesting) {
                        $outdata[] = '$' . sprintf("%-30s = '%s';\n", "TESTING", $setupres['TESTING']);
                        $outtesting = 1;
		            }
                    if (!$outdbpasswcrpt) {
                        // palla incredibile per mettere la variabile prima della connessione
                        $afterk = array_search('$'.sprintf("%-30s = '%s';\n", 'dbpassw', $setupres['dbpassw']), $outdata);
                        $coutdata = count($outdata);
                        for ($x = $afterk + 1, $c = 0; $x <= $coutdata; $x++, $c++)
                        {
                            $tmp_outdata[$c] = $outdata[$x];
                            if ($c > 0) $outdata[$x] = $tmp_outdata[$c - 1];
                        }
                        $outdata[$afterk + 1] = '$' . sprintf("%-30s = '%s';\n", "dbpasswcrpt", $setupres['dbpasswcrpt']);
                        $outdbpasswcrpt = 1;

                        // se non sono ancora state inserite le righe di codice per gestire la criptazione
                        if (!array_search("include_once \$priscilla_local_path.\"packages/crypt/Rc4.php\";\n", $outdata))
                        {
                            // metto il controllo sulla connessione normale
                            $afterk = array_search("\$connh = &ADONewConnection( \$dbtype );\n", $outdata);
                            $coutdata = count($outdata);
                            for ($x = $afterk + 1, $c = 0; $x <= $coutdata; $x++, $c++)
                            {
                                $tmp_outdata[$c] = $outdata[$x];
                                if ($c > 0) $outdata[$x] = $tmp_outdata[$c - 1];
                            }
                            $outdata[$afterk + 1] = "if (!\$dbpasswcrpt)\n";

                            // metto l'inclusione del package crypt
                            $outdata[] = "include_once \$priscilla_local_path.\"packages/crypt/Rc4.php\";\n";

                            // metto la connessione cryptata
                            $outdata[] = "if (\$dbpasswcrpt) {\$ckey = \$priscilla_local_path;\$dbpassw = base64_decode(\$dbpassw);if (\$ckey{strlen(\$ckey) - 1} != \"/\")\$ckey .= \"/\";\$rc4 = new Crypt_RC4(\$ckey);\$rc4->decrypt(\$dbpassw);unset(\$rc4);\$connh->Connect( \$dbhost, \$dbuser, \$dbpassw, \$dbname );}\n";
                        }
                    }
		        }
		        $outdata[] = $setupdata[$i];
	        }
        }
    } // for
    
    if (!$outfirma)
        $outdata[] = $currfirma; 

    // qui si salva....
    $fp = fopen($filename, "w");
    if (!$fp)
        die("Fatal Error: could not write setup file: '$filename'");
    for($i = 0; $i < count($outdata); $i++)
        fputs($fp, $outdata[$i]);
    fclose($fp);
 
}



// wrap lines in $oldstr at $wrap characters. Return $newstr.
function wraplines($oldstr, $wrap)
{
	$oldstr=str_replace("<br />","\n",$oldstr);
	$oldstr=str_replace("<br />","\n",$oldstr);
	$newstr = ""; $newline = "";
	$oldstr .= "\n";
	do
	{
		if (strpos($oldstr, "\n") <= $wrap)
		{
			$i = strpos($oldstr, "\n");
		}
		else
		{
			$i = $wrap;
			while (!ereg("[\n\t ]", substr($oldstr, $i, 1)) && $i > 0)
			{
				$i--;
			}
		}
		$newline = substr($oldstr, 0, $i+1);
		if ($i!=0) $newline[$i] = "\n";
		if ($oldstr[0] != "")
		{
			$oldstr = substr($oldstr, $i+1);
		}
		$newstr .= $newline;
	} while (strlen($oldstr) > 0);
	$newstr = substr($newstr, 0, -1);
return $newstr;
}



/*
 *   my_resize_image
 *
 *   $original_image            nome dell'immagine da convertire con percorso
 *   $new_width, $new_height    dimensioni dell'immagine finale
 *   $output_file               file in cui salvare il risultato
 *
 *   ritorna != 0 in caso di errore
 *
 */

// codici di errore ritornati
$ERR_RESIZE_IMGACCESS = 1;
$ERR_RESIZE_GETSIZENO = 2;
$ERR_RESIZE_UNSUPPFMT = 3;
$ERR_RESIZE_TARGETFMT = 4;

function my_resize_image ($original_image, $new_width, $new_height, $output_file) {
global $ERR_RESIZE_IMGACCESS, $ERR_RESIZE_GETSIZENO, $ERR_RESIZE_UNSUPPFMT, $ERR_RESIZE_TARGETFMT;


// tipi di immagini supportate
$TYPE_GIF = 1;
$TYPE_JPG = 2;
$TYPE_PNG = 3;
$TYPE_BMP = 6;
// qualit&agrave; in uscita per il JPG (volendo si potrebbe dare come parametro esterno)
$JPEG_QUALITY = 80;

    $simulate = 0;


    $set_jpg_quality = "";


    // dimensioni finali debbono essere "decenti"
    if ($new_width < 1 || $new_height < 1)
        return $ERR_RESIZE_TARGETFMT;

    // giusto un controllo iniziale
    if (!is_readable($original_image))
        return $ERR_RESIZE_IMGACCESS;

    // si prendono le dimensioni originali e il tipo dell'immagine
    $size = @getimagesize($original_image);
    
    if ($size == false)
        return $ERR_RESIZE_GETSIZENO;
     
    
    // le costanti IMAGETYPE sono definite da PHP >= 4.3
    //
    // 1 = GIF, 2 = JPG, 3 = PNG, 4 = SWF, 5 = PSD, 6 = BMP,
    // 7 = TIFF INTEL, 8 = TIFF MOTOROLA, ...
      
if (!$simulate) {

    switch ($size[2]) {
    
    /*
    *
    * NOTE SUL FORMATO GIF
    *   
    * La funzione di salvataggio in formato GIF e` stata rimossa dalla libreria GD dalla versione 1.6
    * il brevetto sulle GIF e` scaduto per gli USA non per l'Europa.
    * Occorre attendere il 7 luglio 2004
    * Poi probabilmente GD reintrodurr&agrave; funzioni per salvare GIF
    *
    * Riabilitate le miniature gif (23.9.2009)
    * 
    */

        case 1:
            $srcimage =  imagecreatefromgif ($original_image);
            $savefunc = "imagegif";
            break;           

        case 2:            
            $srcimage =  imagecreatefromjpeg ($original_image);
            $savefunc = "imagejpeg";
            $set_jpg_quality = ', $JPEG_QUALITY';
            break;
            
        case 3:
            $srcimage =  imagecreatefrompng ($original_image);
            $savefunc = "imagepng";
            break;

      /*
     *  NOTE SUL FORMATO BMP
     *
     *  Supporta salvataggio solo in WBMP (WIRELESS BIT MAP)
     *  che riesce solo se l'immagine originale &Egrave; anch'essa in WBMP
     *
     */
/*     
        case 6:
            $srcimage =  imagecreatefromwbmp ($original_image);
            $savefunc = "imagepng";
            break;
*/

        default:
            return $ERR_RESIZE_UNSUPPFMT;
    }
    
    $outimage = imagecreatetruecolor ($new_width, $new_height);

    imagecopyresampled ($outimage, $srcimage,
        0, 0, 0, 0, $new_width, $new_height, $size[0], $size[1]);


    $savecmd = $savefunc . "(" . '$outimage' . ", " . '$output_file' . $set_jpg_quality . ");";
    eval($savecmd);
    
    imagedestroy($srcimage);
    imagedestroy($outimage);    
}
else
    copy($original_image, $output_file);

return 0;
}


function my_extension_ok ($extname) {

    if (! @extension_loaded($extname))
        if (! @dl($extname . '.so'))
            return 0;
return 1;
}

// Restituisce il percorso per la procedura che l'utente sta utilizzando (riferito
// alla dir. principale di Priscilla).
// Cerca nella tabella $ProcsTable del DB di Priscilla il record con l'id pari a $IdProc;
// legge l'id del tipo di prenotazione; legge dalla tabella "tipi_$ProcsTable"
// il record con tale id; infine, estrae dal campo apposito la directory in cui
// la procedura si trova.
// In realt&agrave; unisco i due passi facendo un join tra le due tabelle.
// $Prefix &Egrave; un prefisso opzionale unito al percorso letto nella tabella.
// Se la directory non &Egrave; terminata da un '/', viene aggiunta automaticamente.
function GetProcPath( $connh, $IdProc, $ProcsTable, $Prefix )
{
	$rsProcs = $connh->Execute( "Select p.*, tp.directory As ProcDirectory From ".$ProcsTable." ".
	                            "As p Join tipi_".$ProcsTable." As tp On p.tipo = tp.id ".
	                            "Where p.id = ".$IdProc );

	if ( !$rsProcs )
		die( "Fatal error: Table ".$ProcsTable." not found" );
	$ProcDirectory = $rsProcs->fields( "ProcDirectory" );
	$rsProcs->Close();
	$Path = $Prefix.$ProcDirectory;
	if ( count($Path) > 0 && $Path{count($Path)-1} != "/" )
		$Path .= "/";

	return $Path;
}

// convert un colore da '#000000' ===> R,G,B
function color_from_str ($str, &$r, &$g, &$b) {

    if (strlen($str) != 7)
        return 0;
    if ($str{0} != '#')
        return 0;        
        
    $r = base_convert(substr($str, 1, 2), 16, 10);
    $g = base_convert(substr($str, 3, 2), 16, 10);
    $b = base_convert(substr($str, 5, 2), 16, 10);

    if (($r < 0 || $r > 255) || ($g < 0 || $g > 255) || ($b < 0 || $b > 255))
        return 0;
        
return 1;
}

// generazione e salvataggio di una immagine JPEG vuota
//
// parametri:
// testo, larghezza, altezza, colore background, colore foreground, nomefile in cui salvare
//
function make_jpg_image ($stext, $width, $height, $bg, $fg, $outfile) {
$JPEG_QUALITY = 80;

    $outimage = imagecreate ($width, $height);

    // se i colori in ingresso passano come non buoni si va con quelli di default
    if (!color_from_str($bg, $r1, $g1, $b1))
        $bgc = imagecolorallocate($outimage, 255, 255, 255); 
    else
        $bgc = imagecolorallocate($outimage, $r1, $g1, $b1);    

    if (!color_from_str($fg, $r2, $g2, $b2))
        $fgc = imagecolorallocate($outimage, 0, 0, 0);
    else 
        $fgc = imagecolorallocate($outimage, $r2, $g2, $b2);
    
    
    imagefilledrectangle($outimage, 0, 0, $width - 1, $height - 1, $bgc); 
    imagerectangle($outimage, 0, 0, $width - 1, $height - 1, $fgc);

    // scelta di uno dei font predefiniti
    $font = 3;
    $textwidth = ImageFontWidth($font) * strlen($stext);
    $textheight = ImageFontHeight($font);    

    imagestring ($outimage, $font, ($width - $textwidth) / 2, ($height - $textheight) / 2, $stext, $fgc);

    imagejpeg($outimage, $outfile, $JPEG_QUALITY);
    imagedestroy($outimage);
}

// funzione di correzione ortografica (per salvataggio contenuti al volo
function apply_orto_rules_for_user ($user, $id_content, $table_content) {
global $connh;
$COOKIE_SAVEAPPLY   = 'saveapply';
$COOKIE_TAGSUBSTITUTE = 'tagsubstitute';
$COOKIE_PREF_TYPE   = 'prf';
$TABLE_RULES_NAME   = 'ortografia_rules';

$PREG_PREFIX = "/\b";
$PREG_PREFIX_NUDA = "/\b";

$PREG_POSTFIX = "\B/i";
$PREG_POSTFIX_NUDA = "\b/i";

global $debug;

$debug = 0;


// regole accessibilita'

$tags_b = array (
	'/<b>/i',
	'/<\/b>/i',
	'/<i>/i',
	'/<\/i>/i',
	'/<br>/i',
	'/<hr>/i',
	'/<input ([A-z,0-9,=,",\',_, ]*)>/ei',
	'/<font /i',
	'/<\/font>/i',
	'/ HREF=/i',
	'/ CLASS=/i',
	'/ STYLE=/i',
	'/ COLSPAN=/i',
	'/ ROWSPAN=/i',
	'/ BORDER=/i',
	'/ CELLPADDING=/i',
	'/ CELLSPACING=/i',
	'/ NAME=/i',
	'/ VALUE=/i',
	'/ WIDTH=/i',
	'/ HEIGHT=/i',
	'/ SRC=/i',
	'/ ALT=/i',
	'/ COLS=/i',
	'/ ROWS=/i',
	'/ METHOD=/i',
	'/ ACTION=/i',
	'/ SIZE=/i',
	'/ TYPE=/i',
	'/ ALIGN=/i',
	'/ VALIGN=/i',
	'/ TITLE=/i',
	'/ BGCOLOR=/i',
	'/ BACKGROUND=/i',
	'/ TARGET=/i',
	'/ REL=/i',
	'/ MAXLENGTH=/i',
	'/ HSPACE=/i',
	'/ VSPACE=/i',
	'/ HTTP-EQUIV=/i',
	'/ CONTENT=/i',
	'/<([A-Z,0-9]*[ |>])/e',
	'/<\/([A-Z,0-9]*)>/e',

	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/',
	'/�/'
);

$tags_n = array (
	'<strong>',
	'</strong>',
	'<em>',
	'</em>',
	'<br />',
	'<hr />',
	"'<input '.stripslashes(strtolower('\\1')).' />'",
	'<span ',
	'</span>',
	' href=',
	' class=',
	' style=',
	' colspan=',
	' rowspan=',
	' border=',
	' cellpadding=',
	' cellspacing=',
	' name=',
	' value=',
	' width=',
	' height=',
	' src=',
	' alt=',
	' cols=',
	' rows=',
	' method=',
	' action=',
	' size=',
	' type=',
	' align=',
	' valign=',
	' title=',
	' bgcolor=',
	' background=',
	' target=',
	' rel=',
	' maxlength=',
	' hspace=',
	' vspace=',
	' http-equiv=',
	' content=',
	"strtolower('<\\1')",
	"strtolower('</\\1>')",

	'&Aacute;',
	'&Agrave;',
	'&Acirc;',
	'&Atilde;',
	'&Aring;',
	'&Auml;',
	'&AElig;',
	'&Ccedil;',
	'&Eacute;',
	'&Egrave;',
	'&Ecirc;',
	'&Euml;',
	'&Iacute;',
	'&Igrave;',
	'&Icirc;',
	'&Iuml;',
	'&ETH;',
	'&Ntilde;',
	'&Oacute;',
	'&Ograve;',
	'&Ocirc;',
	'&Otilde;',
	'&Ouml;',
	'&Oslash;',
	'&Uacute;',
	'&Ugrave;',
	'&Ucirc;',
	'&Uuml;',
	'&Yacute;',
	'&THORN;',
	'&szlig;',
	'&aacute;',
	'&agrave;',
	'&acirc;',
	'&atilde;',
	'&aring;',
	'&auml;',
	'&eacute;',
	'&egrave;',
	'&ecirc;',
	'&euml;',
	'&iacute;',
	'&igrave;',
	'&icirc;',
	'&iuml;',
	'&eth;',
	'&ntilde;',
	'&oacute;',
	'&ograve;',
	'&ocirc;',
	'&otilde;',
	'&ouml;',
	'&oslash;',
	'&uacute;',
	'&ugrave;',
	'&ucirc;',
	'&uuml;',
	'&yacute;',
	'&thorn;',
	'&yuml;'
);


    $orto_substitute = true;
    $tag_substitute = true;

    // prima di procedere si va a vedere se questo utente vuole applicare regole
    // durante il salvataggio dei contenuti
    
    $dbquery = "SELECT * FROM $TABLE_RULES_NAME WHERE id_user = '$user' AND `before` ='$COOKIE_SAVEAPPLY' AND snew = '$COOKIE_SAVEAPPLY' AND tipo = '$COOKIE_PREF_TYPE'";
    $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());
    if (!$rowrs->RecordCount()) {
        if ($debug)
            echo "preferenza salvataggio NON trovata<br />\n";
        $orto_substitute = false;
    } else {
        $row = $rowrs->fields;
        if ($row[status] != 'si') {
            if ($debug)
                echo "preferenza salvataggio NON attiva<br />\n";
            $orto_substitute = false;
        }
    }

    // e se sono richieste regole
    // di sostituzione tag per accessibilita'

    $dbquery = "SELECT * FROM $TABLE_RULES_NAME WHERE id_user = '$user' AND `before` ='$COOKIE_TAGSUBSTITUTE' AND snew = '$COOKIE_TAGSUBSTITUTE' AND tipo = '$COOKIE_PREF_TYPE'";
    $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());
    if (!$rowrs->RecordCount()) {
        if ($debug)
            echo "preferenza salvataggio NON trovata<br />\n";
        $tag_substitute = false;
    } else {
        $row = $rowrs->fields;
        if ($row[status] != 'si') {
            if ($debug)
                echo "preferenza salvataggio NON attiva<br />\n";
            $tag_substitute = false;
        }
    }

    // sempre disabilitato
    $tag_substitute = false;

 
    if (!$orto_substitute && !$tag_substitute) {
        if ($debug)
            echo "ritorno perche' nulla da applicare<br />\n";
        return 0;
    }


    if ($orto_substitute) {

        $numattive = 0;
        $mybefore = array();
        $mysnew = array();

        $dbquery = "SELECT * FROM $TABLE_RULES_NAME WHERE id_user = '$user' OR tipo = 'pub'";
        $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());

        if (!$rowrs->RecordCount())
            return 0;

        // costruzione dei vettori delle regole attive
        while (!$rowrs->EOF)  {         
            $row = $rowrs->fields;
            if ($row[tipo] == $COOKIE_PREF_TYPE) {
                $rowrs->MoveNext();        
                continue;
            }
            // se la regola &Egrave; attiva
            if ($row[status] == "si") {
                $numattive++;
                if (trim($row[before]) != '') {
                
                    if (ctype_alpha($row[before]{strlen($row[before]) - 1}))
                        $mybefore[$row[id]] = $PREG_PREFIX . $row[before] . $PREG_POSTFIX_NUDA;
                    else $mybefore[$row[id]] = $PREG_PREFIX . $row[before] . $PREG_POSTFIX;
                    $mysnew[$row[id]] = $row[snew];
                }
            } // if ($row[status]

            $rowrs->MoveNext();
        } // while


        if ($debug) {
            echo "<br />ricerca / sostituzioni:<br />\n";
            print_r($mybefore);
            echo '<br /><br />';
            print_r($mysnew);
        }
    } // if ($orto_substitute


    // se c'e' qualcosa da sostituire...
    if (($numattive && count($mybefore) && count($mysnew)) || $tag_substitute) {
        
        // test per prendere campi utili C -> varchar, X -> text, I -> integer
        $dbquery = "SELECT * FROM $table_content WHERE id = '$id_content'";
        $rowrs = $connh->Execute($dbquery) or die("ERROR:$dbquery<br />".$connh->ErrorMsg());
	    $num_campi = $rowrs->FieldCount();
        $contabuoni = 0;
        if ($rowrs->RecordCount()) {
               $subquery = "UPDATE $table_content SET";
            $row = $rowrs->fields;
            for ($i = 0; $i < $num_campi; $i++) {
                $field = $rowrs->FetchField($i);
		        $type = $rowrs->MetaType($field->type);
		        $name = $field->name;
                if ($debug)
                    echo "$name di tipo $type<br />";
                    
                if (strtoupper($type) == "C" || strtoupper($type) == "X") { 

                    $testo = stripslashes($row[$name]);

                    if ($orto_substitute) {
                        if ($debug)
                            echo "ortosubstitute<br />\n";
                        $testo = preg_replace($mybefore, $mysnew, $testo);
                    }
                    
                    if ($tag_substitute) {
                        if ($debug)
                            echo "tagsubstitute<br />\n";
                        $testo = preg_replace($tags_b, $tags_n, $testo);
                    }

                    if ($debug && trim($testo) != '')
                        echo "TESTO = $testo<br />";

                    if (!$contabuoni)
                        $subquery .= ' ';
                    else $subquery .= ', ';
                    
                    $subquery .= $name . " = '" . addslashes($testo) . "'";
                    $contabuoni++;
                } // if strtoupper
            } // for $i
                 

            $subquery .= " WHERE id = '$id_content'";
            if ($contabuoni) {
                if ($debug)
                    echo $subquery . "<br />\n";                
                $connh->Execute($subquery) or die("ERROR:$subquery<br />".$connh->ErrorMsg());
            }
         

        } // if rowrs->RecordCount()
    } // if ($numattive

        
return $numattive;    
} // function apply_orto_rules_for_user

function get_style_strings($look)
{
    global $priscilla_local_path;
    require $priscilla_local_path."look/".$look.".php";
    // calcolo stili
	$styles = array();

	$style = $look.'_table';
    eval ("\$styles[table] = $$style;");
    $style = $look.'_container';
    eval ("\$styles[container] = $$style;");
	$style = $look.'_tr';
    eval ("\$styles[tr] = $$style;");
	$style = $look.'_td';
    eval ("\$styles[td] = $$style;");
    $style = $look.'_opzione';
    eval ("\$styles[opzione] = $$style;");
	$style = $look.'_titolo';
    eval ("\$styles[titolo] = $$style;");
	$style = $look.'_tvoice';
    eval ("\$styles[tvoice] = $$style;");
	$style = $look.'_link';
    eval ("\$styles[link] = $$style;");
	$style = $look.'_testo';
    eval ("\$styles[testo] = $$style;");
    $style = $look.'_input';
    eval ("\$styles[input] = $$style;");
    $style = $look.'_radio';
    eval ("\$styles[radio] = $$style;");

	return $styles;
}

//----------------------------------------------------------------------
 // EDCONT - edita i contenuti della pagina. realizza la form pescando
//  i nomi dei campi in automatico dalla tabella content_ specificata.
//  se $complete = false non crea la colonna delle etichette e ric
//----------------------------------------------------------------------

function edcont($id, $new_create_section, $complete=true)
{
    require_once PRISCILLA_LOCAL_PATH.'adm/lib/setup.php';
    $lang = $_SESSION['PRISCILLA_SESSION']->getvalue('lingua');
    $usertable = $_SESSION['PRISCILLA_SESSION']->getvalue('usertable');
    $connh = $_SESSION['PRISCILLA_SESSION']->getvalue('connh');
    global $content_table, $content;
    require PRISCILLA_LOCAL_PATH."tools/lang/$lang/dialog.diz";

    $typeditor = $usertable['editor'];

    if (strlen(trim($new_create_section)) > 0)
        $pagename = strtoupper($new_create_section);
    else
        $pagename = strtoupper($content[sezione]);

    $table = $content_table;

    $dbquery = "SELECT * FROM $table WHERE id='$id'";
    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
    $num_campi = $rowrs->FieldCount();

    // controllo per campi enum
    $query = "SHOW COLUMNS FROM $table";
    $rs = $connh->Execute($query) or die("ERROR: $query<br />".$connh->ErrorMsg());
    while (!$rs->EOF)
    {
        if (ereg('enum', $rs->fields[Type])) $enum_fields[$rs->fields[Field]] = $rs->fields[Type];
        $rs->MoveNext();
    }

    echo "<table cellpadding=\"2\" cellspacing=\"1\" border=\"0\" width=\"100%\" class=\"table_border\" id=\"table_cont\">";
    for ($i=0; $i<$num_campi; $i++)
    {
        $field = $rowrs->FetchField($i);
        $value = stripslashes($rowrs->fields[$field->name]);
        $type = $rowrs->MetaType($field->type);
        $name = $field->name;
        $len = $field->max_length;
        if ($len < 0) $len ='';
        $descstr = "desc_".$name;
        if (strstr($$descstr,$name)) $desc = $$descstr;

        if ($name == 'id') {}
        elseif (is_array($enum_fields) && array_key_exists($name, $enum_fields))
        {
            $enum_opts = str_replace('enum', '', $enum_fields[$name]);
            $enum_opts = str_replace('(', '', $enum_opts);
            $enum_opts = str_replace(')', '', $enum_opts);
            $enum_opts = str_replace('\'', '', $enum_opts);
            $enum_opts = explode(',', $enum_opts);
            echo "<tr>";
            if ($complete)
                echo "<td class=\"insert_voice_dark\">$name</td>\n";
            echo "<td class=\"insert_voice_dark\"><select name=\"_$name\" id=\"_$name\" size=\"1\" class=\"insert_area\">";
            foreach ($enum_opts as $val)
            {
                echo "<option value=\"$val\"";
                if ($val == $value) echo 'selected';
                echo ">$val";
            }
            echo "</select>";
            if ($_COOKIE['login'] == 'superuser' && $complete) echo "<input type=\"checkbox\" name=\"".$name."Rec\" value=\"y\"> RIC";
            echo "</td>
            </tr>";
        }
        elseif ($type == 'X')
        {
            if (@include_once PRISCILLA_LOCAL_PATH."packages/FCKeditor/fckeditor.php") {
                $editor = new FCKeditor('_'.$name);
                $edcompatible = $editor->IsCompatible();
            }
            else
                $edcompatible = false;

            if ($typeditor == 'e' && file_exists(PRISCILLA_LOCAL_PATH."modules/fckeditor/inc/config.inc.php")
                                      && is_dir(PRISCILLA_LOCAL_PATH."packages/FCKeditor") && $edcompatible)
            // se ho definito per l'editor in JAVASCRIPT
            {
                echo "<tr>";
                if ($complete)
                    echo "<td valign=\"top\" class=\"insert_voice\">$name</td>";
                echo "<td align=\"left\" class=\"insert_voice\">";

                echo "<input type=\"hidden\" name=\"vised_active\" id=\"vised_active\" value=\"true\" />";

                $editor->BasePath = PRISCILLA_SERVER_PATH."packages/FCKeditor/";
                if ($usertable['htmlLevel'] == '') $usertable['htmlLevel'] = 'no';
                $editor->ToolbarSet = $usertable['htmlLevel'];
                $editor->Config['DefaultLanguage'] = substr($lang, 0, 2);
                $editor->Value = $value;
                flush();
                echo $editor->CreateHTML();
                if ($_COOKIE['login'] == 'superuser' && $complete) echo "<input type=\"checkbox\" name=\"".$name."Rec\" value=\"y\"> RIC";
                echo "</td>
                </tr>";
            }
            else
            {
                $value = ereg_replace("<br />","",$value);
                //$value = htmlspecialchars($value);
                echo "<tr>";
                if ($complete)
                    echo "<td valign=\"top\" class=\"insert_voice\">$name</td>";
                echo "<td align=\"left\" class=\"insert_voice\"><textarea class=\"insert_area\" name=\"_$name\" id=\"_$name\" cols=\"110\" rows=\"25\" wrap=\"virtual\" style=\"width:90%\">$value</textarea>";
                if ($_COOKIE['login'] == 'superuser' && $complete) echo "<input type=\"checkbox\" name=\"".$name."Rec\" value=\"y\"> RIC";
                echo "</td>
                </tr>";
            }
        }
        elseif ($type == 'D')
        {
            preg_match("/([0-9]{4})-([0-9]{2})-([0-9]{2})/", $value, $match);
            $anno = $match[1];
            $mese = $match[2];
            $giorno = $match[3];
            $t_giorno = "<select name=\"_".$name."_dateday\" id=\"_".$name."_dateday\" class=\"insert_area\">\n";
            for ($c = 0; $c <= 31; $c++)
            {
                if ($c == $giorno) $selected = ' selected';
                else $selected = '';
                if ($c < 10) $c = '0'.$c;
                $t_giorno .= "<option value=\"$c\"$selected>$c</option>\n";
            }
            $t_giorno .= "</select>";
            $t_mese = "<select name=\"_".$name."_datemonth\" id=\"_".$name."_datemonth\" class=\"insert_area\">\n";
            for ($c = 0; $c <= 12; $c++)
            {
                if ($c == $mese) $selected = ' selected';
                else $selected = '';
                if ($c < 10) $c = '0'.$c;
                $t_mese .= "<option value=\"$c\"$selected>$c</option>\n";
            }
            $t_mese .= "</select>";
            $t_anno = "<input type=\"text\" name=\"_".$name."_dateyear\" id=\"_".$name."_dateyear\" value=\"$anno\" class=\"insert_area\" size=\"5\" max_length=\"4\">\n";
            echo "<tr>";
            if ($complete)
                echo "<td class=\"insert_voice_dark\">$name</div></td>";
            echo "<td class=\"insert_voice_dark\">".$t_giorno." ".$t_mese." ".$t_anno;
            echo "</td>
</tr>";
        }
        else
        {
            $value = ereg_replace("<br />","",$value);
            $value = htmlspecialchars($value);
            echo "<tr>";
            if ($complete)
                echo "<td class=\"insert_voice_dark\">$name</div></td>";
            echo "<td class=\"insert_voice_dark\"><input class=\"insert_area\" type=\"text\" size=\"30\" maxlength=\"$len\" name=\"_$name\" id=\"_$name\" value=\"$value\" style=\"width:90%\">";
            if ($_COOKIE['login'] == 'superuser' && $complete)
                echo "<input type=\"checkbox\" name=\"".$name."Rec\" value=\"y\"> RIC";
            echo "</td>
</tr>";
        }
    }
    echo "</table>";
}

//----------------------------------------------------------------------
 // EDCONT (versione notable) - edita i contenuti della pagina. realizza la form pescando
//  i nomi dei campi in automatico dalla tabella content_ specificata.
//  se $complete = false non crea la colonna delle etichette e ric
//----------------------------------------------------------------------

function edcont_notable($id, $new_create_section)
{
    require_once PRISCILLA_LOCAL_PATH.'adm/lib/setup.php';
    $lang = $_SESSION['PRISCILLA_SESSION']->getvalue('lingua');
    $usertable = $_SESSION['PRISCILLA_SESSION']->getvalue('usertable');
    $connh = $_SESSION['PRISCILLA_SESSION']->getvalue('connh');
    global $content_table, $content;
    require PRISCILLA_LOCAL_PATH."tools/lang/$lang/dialog.diz";

    $typeditor = $usertable['editor'];

    if (strlen(trim($new_create_section)) > 0)
        $pagename = strtoupper($new_create_section);
    else
        $pagename = strtoupper($content[sezione]);

    $dbquery = "SELECT * FROM $content_table WHERE id='$id'";
    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />".$connh->ErrorMsg());
    $num_campi = $rowrs->FieldCount();

    // controllo per campi enum
    $query = "SHOW COLUMNS FROM $content_table";
    $rs = $connh->Execute($query) or die("ERROR: $query<br />".$connh->ErrorMsg());
    while (!$rs->EOF)
    {
        if (ereg('enum', $rs->fields[Type])) $enum_fields[$rs->fields[Field]] = $rs->fields[Type];
        $rs->MoveNext();
    }

    for ($i = 0; $i < $num_campi; $i++)
    {
        $field = $rowrs->FetchField($i);
        $value = stripslashes($rowrs->fields[$field->name]);
        $type = $rowrs->MetaType($field->type);
        $name = $field->name;
        $len = $field->max_length;
        if ($len < 0) $len ='';
        $descstr = "desc_".$name;
        if (strstr($$descstr,$name))
            $desc = $$descstr;

        if ($name == 'id') {}
        elseif (is_array($enum_fields) && array_key_exists($name, $enum_fields))
        {
            $enum_opts = str_replace('enum', '', $enum_fields[$name]);
            $enum_opts = str_replace('(', '', $enum_opts);
            $enum_opts = str_replace(')', '', $enum_opts);
            $enum_opts = str_replace('\'', '', $enum_opts);
            $enum_opts = explode(',', $enum_opts);
            echo "\n<br /><label for=\"content-$name\" class=\"insert_voice_dark\">$name</label>\n";
            echo "\n<br /><select name=\"_$name\" id=\"content-$name\" size=\"1\" class=\"insert_area\">";
            foreach ($enum_opts as $val)
            {
                echo "<option value=\"$val\"";
                if ($val == $value) echo 'selected';
                echo ">$val";
            }
            echo "</select>";
            if ($_COOKIE['login'] == 'superuser')
                echo "<input type=\"checkbox\" name=\"".$name."Rec\" value=\"y\" /> RIC";
        }
        elseif ($type == 'X')
        {
            if (@include_once PRISCILLA_LOCAL_PATH."packages/FCKeditor/fckeditor.php") {
                $editor = new FCKeditor('_'.$name);
                $edcompatible = $editor->IsCompatible();
            }
            else
                $edcompatible = false;

            if ($typeditor == 'e' && file_exists(PRISCILLA_LOCAL_PATH."modules/fckeditor/inc/config.inc.php")
                                      && is_dir(PRISCILLA_LOCAL_PATH."packages/FCKeditor") && $edcompatible)
            // se ho definito per l'editor in JAVASCRIPT
            {
                echo "\n<br /><label for=\"_$name\" class=\"insert_voice\">$name</label>\n<input type=\"hidden\" name=\"vised_active\" id=\"vised_active\" value=\"true\" />";

                $editor->BasePath = PRISCILLA_SERVER_PATH."packages/FCKeditor/";
                if ($usertable['htmlLevel'] == '')
                    $usertable['htmlLevel'] = 'no';
                $editor->ToolbarSet = $usertable['htmlLevel'];
                $editor->Config['DefaultLanguage'] = substr($lang, 0, 2);
                $editor->Value = $value;
                flush();
                echo $editor->CreateHTML();
                if ($_COOKIE['login'] == 'superuser')
                    echo "<input type=\"checkbox\" name=\"".$name."Rec\" value=\"y\" /> RIC";
            }
            else
            {
                $value = ereg_replace("<br />", '', $value);
                echo "\n<br /><label for=\"_$name\" class=\"insert_voice\">$name</label>";
                echo "\n<br /><textarea class=\"insert_area\" name=\"_$name\" id=\"_$name\" cols=\"110\" rows=\"25\" wrap=\"virtual\" style=\"width:90%\">$value</textarea>";
                if ($_COOKIE['login'] == 'superuser')
                    echo "<input type=\"checkbox\" name=\"".$name."Rec\" value=\"y\" /> RIC";
            }
        }
        elseif ($type == 'D')
        {
            preg_match("/([0-9]{4})-([0-9]{2})-([0-9]{2})/", $value, $match);
            $anno = $match[1];
            $mese = $match[2];
            $giorno = $match[3];
            $t_giorno = "<select name=\"_".$name."_dateday\" id=\"_".$name."_dateday\" class=\"insert_area\">\n";
            for ($c = 0; $c <= 31; $c++)
            {
                if ($c == $giorno) $selected = ' selected';
                else $selected = '';
                if ($c < 10) $c = '0'.$c;
                $t_giorno .= "<option value=\"$c\"$selected>$c</option>\n";
            }
            $t_giorno .= "</select>";
            $t_mese = "<select name=\"_".$name."_datemonth\" id=\"_".$name."_datemonth\" class=\"insert_area\">\n";
            for ($c = 0; $c <= 12; $c++)
            {
                if ($c == $mese) $selected = ' selected';
                else $selected = '';
                if ($c < 10) $c = '0'.$c;
                $t_mese .= "<option value=\"$c\"$selected>$c</option>\n";
            }
            $t_mese .= "</select>";
            $t_anno = "<input type=\"text\" name=\"_".$name."_dateyear\" id=\"_".$name."_dateyear\" value=\"$anno\" class=\"insert_area\" size=\"5\" max_length=\"4\" />\n";

            echo "\n<br /><label class=\"insert_voice_dark\">$name</label>";
            echo "\n<br />".$t_giorno." ".$t_mese." ".$t_anno;
        }
        else
        {
            $value = ereg_replace("<br />","",$value);
            $value = htmlspecialchars($value);
            echo "\n<br /><label class=\"insert_voice_dark\">$name</label>";
            echo "\n<br /><input class=\"insert_area\" type=\"text\" size=\"30\" maxlength=\"$len\" name=\"_$name\" id=\"_$name\" value=\"$value\" style=\"width:90%\" />";
            if ($_COOKIE['login'] == 'superuser')
                echo "<input type=\"checkbox\" name=\"".$name."Rec\" value=\"y\" /> RIC";
        }
    }
}

function isValidPassword ($password) {

    if (!(ereg("^([[:alnum:]]{6,32})$", $password)))
        return false;

    $l = strlen($password);
    $ndigit = 0;

    for ($i = 0; $i < $l; $i++)
        if (ctype_digit($password{$i}))
            $ndigit++;

    if ($ndigit == 0)
        return false;

    return true;

} // isValidPassword

function passwordChange ($oldpassword, $newpassword, $newpassword2, $username, &$errmsg, $connh, $ignoreoldpassword = false) {
    global $lang, $priscilla_local_path;
    require_once "tools/lang/$lang/adm_dialog.diz";
    require_once "tools/lang/$lang/error.diz";



    if (file_exists($priscilla_local_path."modules/security/lib/security_class.php")) {
        require_once $priscilla_local_path."modules/security/lib/security_class.php";
        $sec_obj = new security($connh);
        $sec_prefs = $sec_obj->getSecurityPrefs();
    }

    if ($newpassword != $newpassword2) {
        $errmsg = err_ins_passw;
        return false;
    }
  
    if ($sec_prefs['security_good_passwd']) {
        if (!isValidPassword($newpassword)) {
            $errmsg = adm_user_dummy_password.'<br />'.adm_user_dummy_password_note;
            return false;
        }
    } 

    if ($ignoreoldpassword == false &&  $oldpassword == $newpassword) {
        $errmsg = err_ins_passw;
        return false;
    }

    $dbquery = "SELECT id FROM user WHERE username = '" . $username. "'";

    $rscrypt = $connh->Execute("SELECT SHA1('" . $newpassword . "') as cryptedpass") or die ("Fatal Error: SHA1 function not available.\n");
    $newpassword = $rscrypt->fields('cryptedpass');

    if ($ignoreoldpassword == false) {
        $rscrypt = $connh->Execute("SELECT SHA1('" . $oldpassword . "') as cryptedpass") or die ("Fatal Error: SHA1 function not available.\n");
        $oldpassword = $rscrypt->fields('cryptedpass');
    }

    if ($ignoreoldpassword == false)
        $dbquery .= " AND password = '" . $oldpassword . "'";

    $rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br>" . $connh->ErrorMsg());

    if ($rowrs->RecordCount() <= 0) {
        $errmsg = err_ins_passw;
        return false;
    }
    else $uid = $rowrs->fields['id'];

    $dbquery = "UPDATE user SET password = '$newpassword', lastpasswordchange = NOW() WHERE id = '$uid'";
    $connh->Execute($dbquery) or die("ERROR: $dbquery<br>" . $connh->ErrorMsg());

    return true;
} // passwordChange

function getMysqlServerVersion ($dbhost, $dbuser, $dbpassw) {

mysql_connect($dbhost, $dbuser, $dbpassw) or die ("Could not connect to server '" . $dbhost . "'");
$mysqlversion = mysql_get_server_info();

return $mysqlversion;
}

function jsaddslashes($s)
{
    $o = "";
    $l = strlen($s);
    for($i = 0; $i < $l; $i++)
    {
        $c = $s[$i];
        switch($c)
        {
            case '<': $o .= '\\x3c'; break;
            case '>': $o .='\\x3e'; break;
            case '\'': $o .= '\\\''; break;
            case '\\': $o .= '\\\\'; break;
            case '"':  $o .= '\\"'; break;
//            case "\n": $o .= '\\n'; break;
//            case "\r": $o .= '\\r'; break;
            default:
            $o .= $c;
        }
    }
    return $o;
}

function check_url ($url)
{
    preg_match("/^(\w+:\/\/)?([^\/]+)/i", $url, $matches);
    if (!trim($matches[1]))
        $matches[1] = 'http://';

    return $matches[1].$matches[2];
}

// funzioni utili per bug "mbcs" funzione nativa html_entity_decode
function html_entity_decode_utf8($string)
{
    static $trans_tbl;
   
    // replace numeric entities
    $string = preg_replace('~&#x([0-9a-f]+);~ei', 'code2utf(hexdec("\\1"))', $string);
    $string = preg_replace('~&#([0-9]+);~e', 'code2utf(\\1)', $string);

    // replace literal entities
    if (!isset($trans_tbl))
    {
        $trans_tbl = array();
       
        foreach (get_html_translation_table(HTML_ENTITIES) as $val=>$key)
            $trans_tbl[$key] = utf8_encode($val);
    }
   
    return strtr($string, $trans_tbl);
}

// Returns the utf string corresponding to the unicode value (from php.net, courtesy - romans@void.lv)
function code2utf($num)
{
    if ($num < 128) return chr($num);
    if ($num < 2048) return chr(($num >> 6) + 192) . chr(($num & 63) + 128);
    if ($num < 65536) return chr(($num >> 12) + 224) . chr((($num >> 6) & 63) + 128) . chr(($num & 63) + 128);
    if ($num < 2097152) return chr(($num >> 18) + 240) . chr((($num >> 12) & 63) + 128) . chr((($num >> 6) & 63) + 128) . chr(($num & 63) + 128);
    return '';
}

function getChildrenBranchNumber($connh, $idb, &$count)
{
    $rs = $connh->Execute("SELECT * FROM node WHERE id_parent=".$idb);
    $rc = $rs->RecordCount();
    if ($rc > 0) {
        $count = $count + $rc;
        while (!$rs->EOF) {
            getChildrenBranchNumber($connh, $rs->fields['id'], $count);
            $rs->MoveNext();
        }
    }
}

// converte un numero intero nel carattere corrispondente dell'alfabeto
// secondo l'ordine di lettura. tiene un contatore interno key_c autoincrementante
function itoc($case='M')
{
    static $key_c = 1;

    switch($key_c)
    {
        case 1: $c = $case == 'M' ? 'A' : 'a'; break;
        case 2: $c = $case == 'M' ? 'B' : 'b'; break;
        case 3: $c = $case == 'M' ? 'C' : 'c'; break;
        case 4: $c = $case == 'M' ? 'D' : 'd'; break;
        case 5: $c = $case == 'M' ? 'E' : 'e'; break;
        case 6: $c = $case == 'M' ? 'F' : 'f'; break;
        case 7: $c = $case == 'M' ? 'G' : 'g'; break;
        case 8: $c = $case == 'M' ? 'H' : 'h'; break;
        case 9: $c = $case == 'M' ? 'I' : 'i'; break;
        case 10: $c = $case == 'M' ? 'J' : 'j'; break;
        case 11: $c = $case == 'M' ? 'K' : 'k'; break;
        case 12: $c = $case == 'M' ? 'L' : 'l'; break;
        case 13: $c = $case == 'M' ? 'M' : 'm'; break;
        case 14: $c = $case == 'M' ? 'N' : 'n'; break;
        case 15: $c = $case == 'M' ? 'O' : 'o'; break;
        case 16: $c = $case == 'M' ? 'P' : 'p'; break;
        case 17: $c = $case == 'M' ? 'Q' : 'q'; break;
        case 18: $c = $case == 'M' ? 'R' : 'r'; break;
        case 19: $c = $case == 'M' ? 'S' : 's'; break;
        case 20: $c = $case == 'M' ? 'T' : 't'; break;
        case 21: $c = $case == 'M' ? 'U' : 'u'; break;
        case 22: $c = $case == 'M' ? 'V' : 'v'; break;
        case 23: $c = $case == 'M' ? 'W' : 'w'; break;
        case 24: $c = $case == 'M' ? 'X' : 'x'; break;
        case 25: $c = $case == 'M' ? 'Y' : 'y'; break;
        case 26: $c = $case == 'M' ? 'Z' : 'z'; break;
    }

    $key_c++;

    return $c;
}


function seotitle ($titolo) {

    $strResult = str_ireplace("à", "a", strtolower($titolo));
    $strResult  = str_ireplace("á", "a", $strResult);
    $strResult =  str_ireplace("è", "e", $strResult);
    $strResult =  str_ireplace("é", "e", $strResult);
    $strResult =  str_ireplace("ì", "i", $strResult);
    $strResult =  str_ireplace("í", "i", $strResult);
    $strResult =  str_ireplace("ò", "o", $strResult);
    $strResult =  str_ireplace("ó", "o", $strResult);
    $strResult =  str_ireplace("ù", "u", $strResult);
    $strResult =  str_ireplace("ú", "u", $strResult);
    $strResult =  str_ireplace("ç", "c", $strResult);
    $strResult =  str_ireplace("ö", "o", $strResult);
    $strResult =  str_ireplace("û", "u", $strResult);
    $strResult =  str_ireplace("ê", "e", $strResult);
    $strResult =  str_ireplace("ü", "u", $strResult);
    $strResult =  str_ireplace("ë", "e", $strResult);
    $strResult =  str_ireplace("ä", "a", $strResult);
    $strResult =  str_ireplace("'", " ", $strResult);
 
    $strResult = preg_replace('/[^A-Za-z0-9 ]/', "", $strResult);
    $strResult = trim($strResult);
    $strResult =  preg_replace('/[ ]{2,}/', " ", $strResult);
 
    $strResult = str_replace(" ", "-", $strResult);
 
    return $strResult;

    //return preg_replace('#[^A-Za-z0-9_-]#', '-', strtolower($titolo));
}

function gettitle ($id, $connh) {

    $res = $id;

    $dbquery = "SELECT `contenuto` FROM `node` WHERE `id` = $id LIMIT 1";
    $rs = select($dbquery, $connh);
    if ($rs && $rs->RecordCount()) {
        $dbquery = "SELECT `titolo` FROM `" . $rs->fields('contenuto') . "` WHERE `id` = $id LIMIT 1";
        $rs2 = select($dbquery, $connh);
        if ($rs2 && $rs2->RecordCount())
            $res = seotitle(stripslashes($rs2->fields('titolo')));
    }

return $res;
}

function maketitle ($id, $title, $absolute = true) {

    $page = $id . "/" . $title;
    if ($absolute)
        $page = PRISCILLA_SERVER_PATH . $page;

return $page;
}

function paypal_encrypt($hash, &$output, $storename) {

$store_path = "/var/lib/mercurio/" . $storename . "/";

if (!file_exists($store_path))
    return 12;

$a_dataz = array (
    "MY_KEY_FILE" => $store_path . "my-prvkey.pem",
    "MY_CERT_FILE" => $store_path .  "my-pubcert.pem",
    "PAYPAL_CERT_FILE" => $store_path . "paypal_cert.pem",
    "OPENSSL" => "/usr/bin/openssl"
);

   $error = 0;

    foreach ($a_dataz as $k => $v) {
	$error++;
        if (!file_exists($v)) {
            return $error;
	}
    }

	$error++;

        $openssl_cmd = $a_dataz["OPENSSL"] . " smime -sign -signer " . $a_dataz["MY_CERT_FILE"] . " -inkey " . $a_dataz["MY_KEY_FILE"] .
                " -outform der -nodetach -binary | " . $a_dataz["OPENSSL"] . " smime -encrypt " .
                "-des3 -binary -outform pem " . $a_dataz["PAYPAL_CERT_FILE"];


//	die($openssl_cmd);


        $descriptors = array(
        0 => array("pipe", "r"),
                1 => array("pipe", "w"),
        );

        $process = proc_open($openssl_cmd, $descriptors, $pipes);
    
        if (is_resource($process)) {
                foreach ($hash as $key => $value) {
                        if ($value != "") {
                                fwrite($pipes[0], "$key=$value\n");
                        }
                }
                fflush($pipes[0]);
                fclose($pipes[0]);

                $output = "";
                while (!feof($pipes[1])) {
                        $output .= fgets($pipes[1]);
                }

                fclose($pipes[1]); 
                $return_value = proc_close($process);
                return 0;
        }

return 11;
}


?>
