<?php

// $Id: module_body.inc.php,v 1.4 2010/07/06 15:49:16 riccardo Exp $

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;

require_once "lib/test_auth.php";


include $module_dir."/lang/$lang/community.diz";
include $module_dir."/inc/config.inc.php";

include_once $module_dir."/lib/community_userFields.class.php";
include_once $module_dir."/lib/community_class.php";

$userFieldsObj = new community_userFields($connh);

// estraggo i dati dell'utente (per personalizzazioni)
$usertable = $PRISCILLA_SESSION->getvalue('usertable');

if ($action == 'save')
{
    if ($nome != '' and $proprietario != '')
    {
        if (!isset($_POST['sendmailatreg'])) $_POST['sendmailatreg'] = 0;
        foreach ($_POST as $key=>$val)
        {
            if ($key != 'action')
            {
                $param[$key] = stripslashes($val);
            }
        }
        $communityObj = new community($connh, $param);
        if ($communityObj->save() == 0) $errorMsg = 'Error on insert<br />'.$communityObj->errorMsg;
    }
    else $errorMsg = community_err_required;
    unset($communityObj);
}

if ($action == 'modify')
{
    $communityObj = new community($connh, $id);
}

if ($action == 'modify_user')
{
    foreach ($_POST as $key=>$val)
    {
        if ($key == 'id_community')
        {
            $param[$key] = '';
            foreach ($_POST[$key] as $k=>$v)
                $param[$key] .= $v.',';
            $param[$key] = substr($param[$key], 0, -1);
        }
        elseif ($key != 'action')
        {
            $param[$key] = stripslashes($val);
        }
    }

    $rs = $connh->Execute("SELECT * FROM community_user_content WHERE id='".$id."'");
    $query = $connh->getUpdateSQL($rs, $param, $magicq=true);
    $rs = $connh->Execute($query) or die($query."<br />".$connh->ErrorMsg());
    $action = 'viewusers';
}

if ($action == 'add_user')
{
    $rs = $connh->Execute("SELECT * FROM community_user_content WHERE username='$_POST[username]'");
    if ($rs->RecordCount() > 0) $msg = 'Errore, username gi&agrave; utilizzato';
    else
    {
        foreach ($_POST as $key=>$val)
        {
            if ($key == 'id_community')
            {
                $param[$key] = '';
                foreach ($_POST[$key] as $k=>$v)
                    $param[$key] .= $v.',';
                $param[$key] = substr($param[$key], 0, -1);
            }
            elseif ($key != 'action')
            {
                $param[$key] = stripslashes($val);
            }
        }
        $param['isactivestatus'] = 'yes';
        $rs = $connh->Execute("SELECT * FROM community_user_content WHERE id='-1'") or die($connh->ErrorMsg());
        $query = $connh->getInsertSQL($rs, $param, $magicq=true) or die($connh->ErrorMsg());
        $rs = $connh->Execute($query) or die($connh->ErrorMsg());
    }
    $action = 'viewusers';
}

if ($action == 'deleteuser')
{
    $query = "DELETE FROM community_user_content WHERE id='$id'";
    $rs = $connh->Execute($query);
    $action = 'viewusers';
}

if ($action == 'delete')
{
    $query = "DELETE FROM community_nodes WHERE idc='$id'";
    $rs = $connh->Execute($query);
    $query = "DELETE FROM community WHERE id='$id'";
    $rs = $connh->Execute($query);
}

if ($action == 'add_node')
{
    function addNodesRec($connh, $idc, $idp)
    {
        $query = "SELECT * FROM node WHERE id_parent='$idp'";
        $rs = $connh->Execute($query);
        if ($rs->RecordCount() > 0)
        {
            while (!$rs->EOF)
            {
                $query = "SELECT * FROM community_nodes WHERE idp='".$rs->fields('id')."' && idc='$idc'";
                $rs1 = $connh->Execute($query);
                if ($rs1->RecordCount() <= 0) // se non e' gia' stata inserita sta pagina per sta community
                {
                    $query = "INSERT INTO community_nodes(idc,idp) VALUES('$idc', '".$rs->fields('id')."')";
                    $connh->Execute($query);
                    $query = "UPDATE node SET community='si' WHERE id='".$rs->fields('id')."'";
                    $connh->Execute($query);
                }
                addNodesRec($connh, $idc, $rs->fields('id'));
                $rs->MoveNext();
            }
        }
    }
    if ($idtoadd != '' && is_numeric($idtoadd))
    {
        $query = "SELECT * FROM community_nodes WHERE idp='$idtoadd' && idc='$id'";
        $rs = $connh->Execute($query);
        if ($rs->RecordCount() <= 0) // se non e' gia' stata inserita sta pagina per sta community
        {
            $query = "INSERT INTO community_nodes(idc,idp) VALUES('$id', '$idtoadd')";
            $connh->Execute($query);
            $query = "UPDATE node SET community='si' WHERE id='$idtoadd'";
            $connh->Execute($query);
        }
        if ($_POST[idtoadd_rec] == 'y') addNodesRec($connh, $id, $idtoadd);
    }
    $action = 'viewnodes';
}

if ($action == 'del_node')
{
    if (count($nodes_sel) > 0)
        foreach ($nodes_sel as $key=>$val)
        {
            $query = "DELETE FROM community_nodes WHERE idc='$id' and idp='$val'";
            $rs = $connh->Execute($query) or die("$query<br />".$connh->ErrorMsg());
            $query = "SELECT * FROM community_nodes WHERE idp='$val'";
            $rs = $connh->Execute($query) or die("$query<br />".$connh->ErrorMsg());
            if ($rs->RecordCount() == 0)
            {
                $query = "UPDATE node SET community='no' WHERE id='$val'";
                $rs = $connh->Execute($query) or die("$query<br />".$connh->ErrorMsg());
            }
        }
    $action = 'viewnodes';
}

include("include/OpenWnd.js");

if ($usertable['username'] != 'superuser')
{
    if (!isset($_GET[idcom])) $_GET[idcom] = $_GET[id];
    $where_c = " WHERE proprietario='".$usertable['username']."'";
    $where_cu = " WHERE INSTR(id_community,'".$_GET[idcom]."')";
    $where_n = " WHERE id_user='".$usertable['username']."'";
}
else
{
    $where_c = '';
    $where_cu = '';
    $where_n = '';
}

?>

<?
if ($action == 'viewusers' or $action == 'modifyuser' or $action == 'adduser') { ?>
<table width="<? include(PRISCILLA_LOCAL_PATH."adm/include/"."dim_all.inc.php"); ?>" class="table_border" align="center" cellpadding="3" cellspacing="1" border="0">
<form action="<? echo $PHP_SELF; ?>" method="post" name="userform">
<input type="hidden" name="action" value="<? if ($action == 'modifyuser') echo "modify_user"; elseif ($action == 'adduser') echo "add_user"; ?>">
<?
if (!isset($idcom)) $idcom = $id;

$query = "SELECT * FROM ".COMMUNITY_USER.$where_cu;
$rs = $connh->Execute($query) or die("ERR: $query<br />".$connh->ErrorMsg());

if ($msg != '')
{ ?>
<tr>
    <td colspan="<? echo $rs->FieldCount() + 2; ?>" align="center" class="insert_voice"><?=$msg?></td>
</tr>
<?
    $msg = '';
}
?>
<tr>
    <th colspan="<? echo $rs->FieldCount(); ?>" class="table_tit"><? echo community_viewusers_tit; ?></th>
    <td colspan="2" align="center" class="insert_voice"><a href="<? echo $PHP_SELF; ?>?action=adduser&idcom=<? echo $idcom; ?>"><? echo community_add_user; ?></a></td>
</tr><tr>
<?
for ($i=0; $i<$rs->FieldCount(); $i++)
{
    $field = $rs->FetchField($i);
    echo "<th class=\"table_sez\">".strtoupper($field->name)."</th>";
}
?>
<th colspan="2" width="15%" class="table_sez"><? echo strtoupper(community_action); ?></th>
</tr>
<?
//$rs->MoveFirst();
while (!$rs->EOF)
{
    $user_row = $rs->fields;
    $nodes = explode(",", $user_row[id_community]);
    if (in_array($idcom, $nodes))
    {
        echo "<tr>";
        foreach ($user_row as $key=>$val)
        {
            if ($key == 'id')
            {
                $idval = $val;
                if (($action == 'modifyuser' && $idval == $id) || $action == 'adduser')
                {
                    if ($action != 'adduser') echo "<input type=\"hidden\" name=\"id\" value=\"$idval\">";
                    echo "<input type=\"hidden\" name=\"idcom\" value=\"$idcom\">";
                }
            }
            echo "<td class=\"insert_voice\" align=\"center\">";
            if ($action == 'modifyuser' && $idval == $id && $key == 'id_community')
            {
                echo "<select name=\"id_community[]\" class=\"insert_area\" multiple>";
                $query = "SELECT * FROM community ".$where_c." ORDER BY nome";
                $rs2 = $connh->Execute($query);
                while (!$rs2->EOF)
                {
                    echo "<option value=\"".$rs2->fields('id')."\"";
                    if (in_array($rs2->fields('id'), $nodes)) echo " selected";
                    echo ">".$rs2->fields('nome');
                    $rs2->MoveNext();
                }
                echo "</select>";
            }
            elseif ($action == 'modifyuser' && $idval == $id && $key != 'id')
            {
                if ($key == 'password') echo "<input type=\"password\" name=\"$key\" value=\"$val\" class=\"insert_area\">";
                else echo "<input type=\"text\" name=\"$key\" value=\"$val\" class=\"insert_area\">";
            }
            else
            {
                if ($key == 'password') echo md5($val);
                else echo $val;
            }
            echo "</td>";
        }
        if ($action == 'modifyuser' && $idval == $id) echo "<td colspan=\"2\" align=\"center\" class=\"button_out\"><input type=\"submit\" value=\"save\" class=\"button_in awesome\"></td>";
        else
        echo "<td align=\"center\" class=\"insert_voice\"><a href=\"$PHP_SELF?action=modifyuser&id=".$user_row[id]."&idcom=$idcom\">".community_modify."</a></td>
        <td align=\"center\" class=\"insert_voice\"><a href=\"$PHP_SELF?action=deleteuser&id=".$user_row[id]."&idcom=$idcom\">".community_delete."</a></td>";
        echo "</tr>";
    }
    $rs->MoveNext();
}
if ($action == 'adduser')
{
    $col_names = $connh->MetaColumnNames(COMMUNITY_USER);
    echo "<tr>";
    foreach ($col_names as $key=>$val)
    {
        if ($val == 'id' || $val == 'activationcookie' || $val == 'isactivestatus' || $val == 'time_request' || $val == 'time_activation' || $val == 'time_remove') echo "<td class=\"insert_voice\">&nbsp;</td>";
        elseif ($val == 'id_community')
        {
            echo "<td align=\"center\" class=\"insert_voice\">
            <select name=\"id_community[]\" class=\"insert_area\" multiple>";
            $query = "SELECT * FROM community ".$where_c." ORDER BY nome";
            $rs = $connh->Execute($query);
            while (!$rs->EOF)
            {
                if ($rs->fields('id') == $idcom) $selected = 'selected';
                else $selected = '';
                echo "<option value=\"".$rs->fields('id')."\" $selected>".$rs->fields('nome');
                $rs->MoveNext();
            }
            echo "</select></td>";
        }
        elseif ($val == 'password')
            echo "<td class=\"insert_voice\"><input type=\"password\" name=\"$val\" class=\"insert_area\"></td>";
        else echo "<td class=\"insert_voice\"><input type=\"text\" name=\"$val\" class=\"insert_area\"></td>";
    }
    echo "<td colspan=\"2\" align=\"center\" class=\"button_out\"><input type=\"submit\" value=\"save\" class=\"button_in awesome\"></td>";
    echo "</tr>";
}
?>
</form>
</table><br />

<? } elseif ($action == 'viewnodes' or $action == 'addnode') { ?>

<table width="<? include("include/"."dim_all.inc.php"); ?>" class="table_border" align="center" cellpadding="3" cellspacing="1" border="0">
<tr><form action="<? echo $PHP_SELF; ?>" method="post" name="nodesform">
    <input type="hidden" name="action" value="add_node" />
    <input type="hidden" name="id" value="<? echo $id; ?>">
    <th colspan="4" class="table_tit"><? echo community_viewnodes_tit; ?> <? echo $id; ?></th>
    <td colspan="2" align="center" class="button_out"><? echo community_add_node; ?><br />
    <select name="idtoadd" class="insert_area">
    <?
    $query = "SELECT * FROM node ".$where_n." ORDER BY sezione";
    $rs = $connh->Execute($query);
    while (!$rs->EOF)
    {
        echo "<option value=\"".$rs->fields('id')."\">".$rs->fields('sezione');
        $rs->MoveNext();
    }
    ?>
    </select>
    RIC <input type="checkbox" name="idtoadd_rec" value="y" />&nbsp;<input type="submit" value="<? echo strtoupper(community_save); ?>" class="button_in awesome"></td>
</tr></form><tr>
    <th width="15%" align="center" class="table_sez"><? echo strtoupper(community_id); ?></th>
    <th width="20%" align="center" class="table_sez"><? echo strtoupper(community_node_sezione); ?></th>
    <th width="20%" align="center" class="table_sez"><? echo strtoupper(community_node_proprietario); ?></th>
    <th width="20%" align="center" class="table_sez"><? echo strtoupper(community_node_visite); ?></th>
    <th width="20%" align="center" class="table_sez"><? echo strtoupper(community_node_lastmod); ?></th>
    <th width="5%" align="center" class="table_sez"><? echo strtoupper(community_action); ?></th>
</tr><form action="<? echo $PHP_SELF; ?>" method="post" name="nodesform">
    <input type="hidden" name="id" value="<? echo $id; ?>">
    <input type="hidden" name="action" value="del_node" /><?
    $query = "SELECT * FROM community_nodes WHERE idc='".$id."'";
    $rs1 = $connh->Execute($query);
    while(!$rs1->EOF)
    {
        $query = "SELECT * FROM node WHERE id='".$rs1->fields('idp')."'";
        $rs2 = $connh->Execute($query);
        if ($rs2->RecordCount() <= 0)
        {
            $query = "DELETE FROM community_nodes WHERE id='".$rs1->fields['id']."'";
            $connh->Execute($query);
            $rs1->MoveNext();
            continue; // se magari la pag � stata cancellata
        }
        $noderow = $rs2->fields;

        ereg("([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})", $noderow[lastmod], $regs);
        $noderow[lastmod] = "$regs[3]-$regs[2]-$regs[1]";
        echo "<tr>
        <td align=\"center\" class=\"insert_voice\">$noderow[id]</td>
        <td align=\"center\" class=\"insert_voice\">$noderow[sezione]</td>
        <td align=\"center\" class=\"insert_voice\">$noderow[id_user]</td>
        <td align=\"center\" class=\"insert_voice\">$noderow[visite]</td>
        <td align=\"center\" class=\"insert_voice\">$noderow[lastmod]</td>
        <td align=\"center\" class=\"insert_voice\"><input type=\"checkbox\" name=\"nodes_sel[]\" value=\"$noderow[id]\"></td>
        </tr>";
        $rs1->MoveNext();
    }
?>
</tr><tr>
    <td colspan="5" class="button_out">&nbsp;</td>
    <td class="button_out"><input type="submit" value="<? echo strtoupper(community_delete); ?>" class="button_in awesome"></td>
</tr>
</table><br />

<? } else {?>

<table width="<? include("include/"."dim_all.inc.php"); ?>" class="table_border" align="center" cellpadding="3" cellspacing="1" border="0">
<form action="<? echo $PHP_SELF; ?>" method="post" name="myform">
<input type="hidden" name="action" value="save" />
<input type="hidden" name="id" value="<? echo $communityObj->id; ?>">
<input type="hidden" name="nodes" value="" />
<tr>
    <th colspan="4" class="table_tit"><? echo community_tit; ?> <span class="insert_message"><?php echo strtoupper($dbname); ?></span></th>
</tr><tr>
    <th colspan="4" width="100%" class="table_sez"><? echo community_tit_red; ?></th>
</tr><tr>
    <td width="25%" align="center" class="insert_voice"><input type="text" name="nome" value="<? echo $communityObj->nome; ?>" size="16" maxlength="255" class="insert_area" style="width:100%"><br /><? echo community_name; ?></td>
    <td width="25%" align="center" class="insert_voice"><select name="proprietario" size="1" class="insert_area" style="width:100%"><?
    if ($usertable['username'] == 'superuser')
    {
        if ($communityObj->proprietario != '') echo "<option value=\"".$communityObj->proprietario."\" selected>".$communityObj->proprietario;
        else echo "<option value=\"\">";
        $dbquery = "SELECT username FROM user ORDER BY username";
        $rowrs = $connh->Execute($dbquery);
        while (!$rowrs->EOF)
        {
            $row = $rowrs->fields;
            echo "<option value=\"$row[username]\">$row[username]</option>\n";
            $rowrs->MoveNext();
        }
    }
    else echo "<option value=\"".$usertable['username']."\">".$usertable['username']."</option>";
    ?></select><br /><? echo community_user; ?></td>
    <td width="25%" align="center" class="insert_voice"><textarea class="insert_area" name="descrizione" cols="110" rows="1" style="width:100%"><?php echo $communityObj->descrizione; ?></textarea><br /><? echo community_desc; ?></td>
</tr><tr>
    <td width="25%" align="center" class="insert_voice"><select name="lingua" size="1" class="insert_area" style="width:100%"><?
    if ($communityObj->lingua != '') echo "<option value=\"".$communityObj->lingua."\" selected>".$communityObj->lingua;
    else echo "<option value=\"\">";
    clearstatcache();
    if ($dir = @opendir('../modules/community/lang/'))
    {
        while ($file = readdir($dir))
        {
            if (($file != ".") && ($file != ".."))
            {
                echo "<option value=\"$file\">".$file;
            }
        }
    }
    ?></select><br /><? echo community_lang; ?></td>
    <td width="25%" align="center" class="insert_voice"><select name="idperrore" size="1" class="insert_area" style="width:100%"><?
    if ($communityObj->idperrore != '')
    {
        $query = "SELECT id,sezione FROM node WHERE id='".$communityObj->idperrore."'";
        $rs = $connh->Execute($query) or die("Error page id do not exists");
        echo "<option value=\"".$rs->fields('id')."\" selected>".$rs->fields('sezione')."</option>";
    }
    else echo "<option value=\"\"></option>";
    $dbquery = "SELECT id, sezione FROM node ORDER BY sezione";
    $rowrs = $connh->Execute($dbquery);
    while (!$rowrs->EOF)
    {
        $row = $rowrs->fields;
        echo "<option value=\"$row[id]\">$row[sezione]</option>\n";
        $rowrs->MoveNext();
    }
    ?></select><br /><? echo community_iderr; ?></td>
    <td width="25%" align="center" class="insert_voice"><input type="checkbox" name="sendmailatreg" value="1" <? if ($communityObj->sendmailatreg == 1) echo 'checked'; ?>><? echo community_send_user_mail; ?></td>
</tr><tr>
    <td align="center" colspan="4" class="button_out"><input type="submit" value="<? echo community_save; ?>" class="button_in awesome"></td>
</tr></form><? if ($errorMsg != '') echo "<tr>
<td colspan=\"4\" class=\"table_sez\" align=\"center\"><span class=\"insert_message\">$errorMsg</span></td>
</tr>";
?>
</table><br />

<? } ?>

<table width="<? include PRISCILLA_LOCAL_PATH."adm/include/dim_all.inc.php"; ?>" class="table_border" align="center" cellpadding="3" cellspacing="1" border="0">
<tr>
    <th colspan="5" class="table_tit"><? echo community_tit_resume; ?></th>
    <td colspan="3" align="center" class="insert_voice"><a href="javascript:OpenWnd('<? echo PRISCILLA_SERVER_PATH; ?>adm/add_field.php?table=community_user_content&relationTable=community_userFields')"><? echo community_set_fields; ?></a></td>
    <td colspan="2" align="center" class="insert_voice"><a href="<? echo $_SERVER[PHP_SELF]; ?>"><? echo community_add_community; ?></a></td>
</tr><tr>
    <th width="5%" class="table_sez"><? echo strtoupper(community_id); ?></th>
    <th width="15%" class="table_sez"><? echo strtoupper(community_name); ?></th>
    <th width="15%" class="table_sez"><? echo strtoupper(community_user); ?></th>
    <th width="15%" class="table_sez"><? echo strtoupper(community_lang); ?></th>
    <th width="15%" class="table_sez"><? echo strtoupper(community_iderr); ?></th>
    <th class="table_sez"><? echo strtoupper(community_desc); ?></th>
    <th class="table_sez"><? echo strtoupper(community_totpages); ?></th>
    <th class="table_sez"><? echo strtoupper(community_viewusers); ?></th>
    <th colspan="2" class="table_sez"><? echo strtoupper(community_action); ?></th>
</tr><?
$query = "SELECT * FROM community ".$where_c;
$rs = $connh->Execute($query);
while (!$rs->EOF)
{
    $param = $rs->fields;
    $rs1 = $connh->Execute("SELECT id FROM community_nodes WHERE idc='".$rs->fields('id')."'");
    $rs2 = $connh->Execute("SELECT sezione FROM node WHERE id='".$param[idperrore]."'");
    $rs3 = $connh->Execute("SELECT id FROM community_user_content WHERE id_community REGEXP '(^|,)".$rs->fields('id')."(,|$)'");

    echo "<tr>
    <td align=\"center\" class=\"insert_voice\">".$param['id']."</td>
    <td align=\"center\" class=\"insert_voice\">".$param['nome']."</td>
    <td align=\"center\" class=\"insert_voice\">".$param['proprietario']."</td>
    <td align=\"center\" class=\"insert_voice\">".$param['lingua']."</td>
    <td align=\"center\" class=\"insert_voice\">".$rs2->fields('sezione')."</td>
    <td align=\"center\" class=\"insert_voice\">".$param['descrizione']."</td>
    <td align=\"center\" class=\"insert_voice\"><a href=\"$_SERVER[PHP_SELF]?action=viewnodes&id=$param[id]\" title=\"".community_viewnodes_tit."\">".$rs1->RecordCount()."</a></td>
    <td align=\"center\" class=\"insert_voice\"><a href=\"$_SERVER[PHP_SELF]?action=viewusers&id=".$param[id]."\" title=\"".community_viewusers_tit."\">".$rs3->RecordCount()."</a></td>
    <td align=\"center\" class=\"insert_voice\"><a href=\"$_SERVER[PHP_SELF]?action=modify&id=".$param['id']."\">".community_modify."</a></td>
    <td align=\"center\" class=\"insert_voice\"><a href=\"$_SERVER[PHP_SELF]?action=delete&id=".$param['id']."\">".community_delete."</a></td>
    </tr>";

    $rs->MoveNext();
}

?>
</table><br />
