<?php

// $Id: pdfgen.php,v 1.16 2006/03/28 09:34:29 calicant Exp $
//
// generazione di un PDF dal referer
//
//

require_once "../../../adm/lib/setup.php";

$debug = 0;

$CHUNK = 4096;
$dirtosave = PRISCILLA_LOCAL_PATH . "modules/core/pdf";
$pagetocall = $_SERVER['HTTP_REFERER'];

// se non abbiam pagina o id del chiamante, ritorniamo alla index
if (trim($pagetocall) == '' || !is_numeric($_GET['id'])) {
    header("Location: ../../../index.php");
    die();
}

// alla ricerca del nome del documento
$docname = '';
// ci andriamo a prendere un nome buono
$dbquery = "SELECT `contenuto` FROM node WHERE id = " . $_GET['id'] . " LIMIT 1";
$rowrs = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());
if ($rowrs->RecordCount()) {
    $dbquery = "SELECT `titolo` FROM `" . $rowrs->fields('contenuto') . "` WHERE `id` = " . $_GET['id'] . " LIMIT 1";
    $rowrs2 = $connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $connh->ErrorMsg());
    $docname = $rowrs2->fields('titolo');
}

if (trim($docname) == '')
    $docname = $_GET['id']; // oppure: $docname = uniqid('pdf_');
else
    $docname = ereg_replace('[/\\]', '_', $docname);


if ($debug)
    echo "pagetocall = $pagetocall<br />\n";

if (!file_exists($dirtosave)) {
    if ($debug)
        echo "create pdf dir \"$dirtosave\"<br />\n";
    if (!@mkdir($dirtosave, 0700))
	die("Fatal Error: unable to create directory \"$dirtosave\"\n");
}

// s'attacca l'estensione
$docname .= '.pdf';
// file pdf da salvare
$pdfFile = $dirtosave . '/' . $docname;
if ($debug)
    echo "pdf output doc = $pdfFile<br />\n";
 
// togliamo il vecchio, tanto per stare dalla parte dei bottoni...
@unlink($pdfFile);

$have_error_msg = '';

$pdf_options = "-q --load-error-handling ignore ";

// se si vogliono anche le sotto pagine
if ($_GET['tree'] == 'yes') {

    $dbquery = "SELECT `id` FROM `node` WHERE `id_parent` = " . $_GET['id'];
    $rs = select($dbquery, $connh);
    if (!$rs)
        die("Fatal Error: " . $connh->ErrorMsg());
    if ($rs->RecordCount())
        while (!$rs->EOF) {
            $cpage = PRISCILLA_SERVER_PATH . "index.php?id=" . $rs->fields('id');
            $pagetocall = $pagetocall . " " . $cpage;
            $rs->MoveNext();
        }
}


$cmd = "/usr/bin/wkhtmltopdf " . $pdf_options . $pagetocall . " \"" . $pdfFile .  "\" 2>&1";
//die($cmd);

$tmp_result = array();
if ($debug)
    echo "COMMAND: $cmd<br />";

exec($cmd, $tmp_result, $retCode);

if ($retCode != 0 && (!file_exists($pdfFile) || filesize($pdfFile) < 9))
    $have_error_msg = "Fatal Error: PDF document not available.";

// check if the result was an error
if ($have_error_msg != '') {
    @unlink($pdfFile);
    die($have_error_msg);
}
else {

    header("Content-type: application/pdf");
    header("Expires: 0");

//    header("Content-Description: File Transfer"); 
//    header("Content-Transfer-Encoding: binary");
    
//    header('Content-Disposition: attachment; filename="' . $docname . '"');

    header('Content-Disposition: filename="' . $docname . '"');


    header('Pragma: no-cache');
    header("Accept-Ranges: bytes");
    header("Content-Length: " . filesize($pdfFile));

    @readfile($pdfFile);
} // else




if ($debug)
    echo "Removing pdf file $pdfFile<br />\n";
@unlink($pdfFile);

?>
